var EXPORTED_SYMBOLS = ['CBingParser'];

var CBingParser = function(p){this.p=p};
var ClassConstructor = CBingParser;

/* inherit CYahooParser from CParser */
Components.utils.import("resource://similarius/base/parser.jsm");
(function(c,p){var f=function(){};f.prototype=p.prototype;c.prototype=new f();c.prototype.constructor=c})(CBingParser,CParser);

/* PARSE PARAMETERS */
	ClassConstructor.prototype.getResperpage = function(){
			/* try to see it on query string */
			var getstring = this.p.url.replace(/^[^\/]*\//, '').replace(/#.*$/, '');
			var matches = getstring.match(/\bcount=(\d+)\b/);
			if (matches)
			{
				var resperpage = parseInt(matches[1],10);
				var available_resperpages = [10,15,20,30,40,100];
				for (var i = 0; i < avalable_resperpages; i++)
					if (resperpage == available_resperpages[i])
						return resperpage;
			};
			
			/* get cookies */
			var cookie = this.p.ST.cookieSvc.getCookieString(this.p.uri_object, null); 
			if (cookie === null) return 10;

			/* check results per page */
			var cookie_matches = cookie.match(/(^|&)NRSLT=(\d+)(&|$)/);
			if (cookie_matches) return cookie_matches[2];
			
			return 10;
		}

	ClassConstructor.prototype.getStart = function() {
			var getstring = this.p.url.replace(/^[^\/]*\//, '').replace(/#.*$/, '');
			var matches = getstring.match(/\bfirst=(\d+)\b/);
			if (!matches) return null;
			var start = parseInt(matches[1],10);
			return start ? start - 1 : 0;
		}

	ClassConstructor.prototype.getKeyword = function() {
			var keywordInput = this.p.doc.getElementById('sb_form_q');
			if (keywordInput) return keywordInput.value;
			
			var keywordInputs = this.p.doc.getElementsByTagName('input')
			for (var i = 0; i < keywordInputs.length; i++)
				if (keywordInputs[i].type && keywordInputs[i].type == 'text' && keywordInputs[i].value)
					return keywordInputs[i].value;
			return null;
		}

	ClassConstructor.prototype.getPage = function() {
			var divs = this.p.doc.getElementsByClassName('sb_pagS');
			return (divs.length && divs[0].textContent) ? divs[0].textContent.replace(/\D/, '') : null;
		}


/* CHECK IF REGULAR SEARCH */
	ClassConstructor.prototype._search_is_regular1 = function(_url) {
			/* язык */
			var url = _url !== undefined ? _url : this.p.url
			if (/\bfilt=all\b/.test(url)) return true;
			if (/\bfilt=custom\b/.test(url)) return false;
			if (/\bfilt=lf\b/.test(url)) return false;
			if (/\blf=1\b/.test(url)) return false;
			if (/\bcustom=1\b/.test(url)) return false;
			return true;
		}
	ClassConstructor.prototype._search_is_regular2 = function(_url) {
			/* за какое время */
			var url = _url !== undefined ? _url : this.p.url
			return /\btbs=qdr:[dwm]\b/.test(url) ? false : true;
		}
	ClassConstructor.prototype._search_is_regular3 = function(_url) {
			/* из какой страны */
			var url = _url !== undefined ? _url : this.p.url
			return /\brf=1\b/.test(url) ? false : true;
		}
	ClassConstructor.prototype.SearchIsRegular = function(_url) {
			if (!this._search_is_regular1(_url)) { this.p.ST.debug(5, 'Not regular 1'); return false; };
			if (!this._search_is_regular2(_url)) { this.p.ST.debug(5, 'Not regular 2'); return false; };
			if (!this._search_is_regular3(_url)) { this.p.ST.debug(5, 'Not regular 3'); return false; };
			return true;
		}

/* PARSE */
ClassConstructor.prototype.Parse = function() {
		var elems = [];
		var arr = this.p.doc.getElementsByTagName('li');

		sb_ans__ismet = false; /* first occurence of <li class="sb_ans"> is a first result; second occurence must be omitted */
		
		for (var i = 0; i < arr.length; i++)
		{
			/* filter results */
			if (/\bsb_ans\b/.test(arr[i].className)) { if (sb_ans__ismet) continue; sb_ans__ismet = true; }
			else if (!/\bsa_wr\b/.test(arr[i].className)) continue;
			
			/* find <div class="vsc"> */
			var elem_div = null;
			var elem_divs = arr[i].getElementsByTagName('div');
			if (elem_divs.length > 0)
				for (var j = 0; j < elem_divs.length; j++)
					if (/\bsa_cc\b/.test(elem_divs[j].className))
						{ elem_div = elem_divs[j]; break; };
			if (!elem_div)
				if (arr[i].childNodes.length == 1)
					elem_div = arr[i].firstChild;
			
			/* main url */
			var mainURL = null;
			var headers = (elem_div ? elem_div : arr[i]).getElementsByTagName('h3');
			if (headers.length)
			{
				var links = headers[0].getElementsByTagName('a');
				if (links.length) mainURL = links[0].href;
			};
			if (!mainURL || mainURL.indexOf('http://'+this.p.host+'/search') === 0 || mainURL.indexOf('https://'+this.p.host+'/search') === 0) continue;
			
			var green_url_tags = elem_div.getElementsByTagName('cite');
			var green_url_lasttag = green_url_tags[green_url_tags.length - 1];

			elems.push({'url': mainURL, 'li': arr[i], 'div': elem_div, 'green_url_lasttag': green_url_lasttag});
		};
		
		return elems;
	}
