var EXPORTED_SYMBOLS = ['CGoogleParser'];

var CGoogleParser = function(p){this.p=p};
var ClassConstructor = CGoogleParser;

/* inherit CGoogleParser from CParser */
Components.utils.import("resource://similarius/base/parser.jsm");
(function(c,p){var f=function(){};f.prototype=p.prototype;c.prototype=new f();c.prototype.constructor=c})(CGoogleParser,CParser);

ClassConstructor.prototype.getKeyword = function() {
		var keywordInputs = this.p.doc.getElementsByTagName('input')
		for (var i = 0; i < keywordInputs.length; i++)
			if (keywordInputs[i].type && keywordInputs[i].type == 'text' && keywordInputs[i].value)
				return keywordInputs[i].value;
		return null;
	};

ClassConstructor.prototype.getStart = function() {
		var getstring = this.p.url.replace(/^[^\/]*\//, '').replace(/#.*$/, '');
		var matches = getstring.match(/\bstart=(\d+)\b/);
		if (!matches) return null;
		return parseInt(matches[1],10);
	};

ClassConstructor.prototype.getPage = function(){
			var pagesTable = this.p.doc.getElementById('nav');
			if (!pagesTable || !pagesTable.rows || !pagesTable.rows.length || !pagesTable.rows[0] || !pagesTable.rows[0].cells || !pagesTable.rows[0].cells.length) return null;
			for (var i = 0; i < pagesTable.rows[0].cells.length; i++)
			{
				var cell = pagesTable.rows[0].cells[i];
				
				// google design ver1
				if (/\bcur\b/.test(cell.className))
				{
					var page = cell.innerHTML.replace(/<[^>]*>/g, ' ').replace(/\D/g, '');
					if (page) page = parseInt(page,10);
					if (page) return page;
				}
				
				// google design ver2
				var bolds = cell.getElementsByTagName('b');
				for (var j = 0; j < bolds.length; j++)
				{
					var num = bolds[j].innerHTML;
					if (/^\d+$/.test(num))
						return num;
				};
			};
			return null;
		};
 
ClassConstructor.prototype.getResperpage = function() {
		/* get cookies */
		var cookie = this.p.ST.cookieSvc.getCookieString(this.p.uri_object, null); 
		if (cookie === null) return 10;

		/* check if instant search */
		var is_instant_search = false;
		var cookie_matches = cookie.match(/(^|:)SG=(\d+)(:|$)/);
		if (cookie_matches && cookie_matches[2] == '1') return 10;
		
		/* try to see it in the query string */
		var getstring = this.p.url.replace(/^[^\/]*\//, '').replace(/#.*$/, '');
		var matches = getstring.match(/\bnum=(\d+)\b/);
		if (matches) return parseInt(matches[1],10);
		
		/* try to see it in the cookie */
		var cookie_matches = cookie.match(/(^|:)NR=(\d+)(:|$)/);
		if (cookie_matches) return cookie_matches[2];
		
		return 10;
	};

ClassConstructor.prototype._search_is_regular1 = function() {
		var _ms = this.p.doc.getElementById('ms');
		if (!_ms) _ms = this.p.doc.getElementById('modeselector');
		if (!_ms) return true;
		var _lis = _ms.getElementsByTagName('li');
		if (!_lis.length || /\bmsel\b/.test(_lis[0].className)) return true;
		return false;
	};
ClassConstructor.prototype._search_is_regular1_1 = function() {
		var _ms = this.p.doc.getElementById('hdtb_msb');
		if (!_ms) return true;
		var _lis = _ms.getElementsByClassName('hdtb_mitem');
		if (!_lis.length || /\bhdtb_msel\b/.test(_lis[0].className)) return true;
		return false;
	};
ClassConstructor.prototype._search_is_regular2 = function() {
		var _taw = this.p.doc.getElementById('taw');
		if (!_taw) return true;
		var _spans = _taw.getElementsByClassName('std');
		for (var i = 0; i < _spans.length; i++)
			if (_spans[i].tagName == 'SPAN' && _spans[i].innerHTML.replace(/\s/g,''))
				return false;
		return true;
	};
ClassConstructor.prototype._search_is_regular2_1 = function() {
		var _menus = this.p.doc.getElementById('hdtbMenus');
		if (!_menus) return true;
		var _uls = _menus.getElementsByTagName('ul');
		for (var i = 0; i < _uls.length; i++)
		{
			var _lis = _uls[i].getElementsByTagName('li');
			var _ind = -1;
			for (var j = 0; j < _lis.length && _ind == -1; j++)
				if (/\bhdtbSel\b/.test(_lis[j].className))
					_ind = j;
			if (_ind > 0)
				return false;
		};
		return true;
	};
ClassConstructor.prototype._search_is_regular2_2 = function() {
		var modeselector = this.p.doc.getElementById('modeselector');
		if (!modeselector) return true;
		for (var div = modeselector.nextSibling; div; div = div.nextSibling)
		{
			var uls = div.getElementsByTagName ? div.getElementsByTagName('ul') : [];
			for (var i = 0; i < uls.length; i++)
			{
				// current <ul>
				var ul = uls[i];
				
				// <ul> containing other sub-<ul>s must be ignored
				var sub_uls = ul.getElementsByTagName('ul');
				if (sub_uls && sub_uls.length) continue;
				
				// every <ul> must not have selected <li>s or selected <li> must be the first one
				var lis = ul.getElementsByTagName('li');
				var _ind = -1;
				for (var j = 0; j < lis.length && _ind == -1; j++)
					if (/\btbos\b/.test(lis[j].className))
						_ind = j;
				if (_ind > 0)
					return false;
			};
		};
		return true;
	};
	
ClassConstructor.prototype.SearchIsRegular = function() {
		return (this._search_is_regular1() && this._search_is_regular1_1() && this._search_is_regular2() && this._search_is_regular2_1() && this._search_is_regular2_2());
	};

/* PARSE */
ClassConstructor.prototype.Parse = function() {
		var elems = [];
		var arr = this.p.doc.getElementsByTagName('li');
		
		for (var i = 0; i < arr.length; i++)
		{
			/* filter results */
			if (!/\bg\b/.test(arr[i].className)) continue;
			if (arr[i].id == 'videobox') continue;
			if (arr[i].id == 'newsbox') continue;
			if (arr[i].id == 'imagebox') continue;
			if (arr[i].id == 'imagebox_bigimages') continue;
			if (arr[i].id == 'lclbox') continue;
			if (arr[i].id == 'booksbox') continue;
			if (/\bbooksbox\b/.test(arr[i].className)) continue;
			
			/* find <div class="vsc"> */
			var elem_div = null;
			var elem_divs = arr[i].getElementsByTagName('div');
			if (elem_divs.length > 0)
				for (var j = 0; j < elem_divs.length; j++)
					if (/\bvsc\b/.test(elem_divs[j].className) || /\brc\b/.test(elem_divs[j].className))
						{ elem_div = elem_divs[j]; break; };
			if (!elem_div)
				if (arr[i].childNodes.length == 1)
					elem_div = arr[i].firstChild;
			
			/* additional filter */
			if (elem_div && /\bnulead\b/.test(elem_div.className)) continue;

			/* main url */
			var mainURL = null;
			var headers = (elem_div ? elem_div : arr[i]).getElementsByTagName('h3');
			if (headers.length)
			{
				var links = headers[0].getElementsByTagName('a');
				if (links.length) mainURL = links[0].href;
			};
			
			/* additional filters */
			if (!mainURL) continue;
			if (mainURL.indexOf('http://'+this.p.host+'/search') === 0) continue;
			if (mainURL.indexOf('https://'+this.p.host+'/search') === 0) continue;
			if (mainURL.indexOf('http://maps.'+this.p.host.replace(/^www\./,'')) === 0) continue;
			if (mainURL.indexOf('https://maps.'+this.p.host.replace(/^www\./,'')) === 0) continue;
			if (mainURL.indexOf('https://maps.google.com') === 0) continue;
			if (mainURL.indexOf('http://maps.google.com') === 0) continue;
			
			// fix for urls that lead to googlestat page
			var s = 'http://'+this.p.host+'/url?';
			if (mainURL.indexOf(s) === 0)
			{
				var p = mainURL.substr(s.length).split('&');
				for (var _i = 0; _i < p.length; _i++)
					if (p[_i].indexOf('q=') === 0)
						{ mainURL = decodeURIComponent(p[_i].substr(2)); break; }
			};
			
			// get green_url_tag
			var green_url_tags = (elem_div && elem_div.getElementsByTagName)
				? elem_div.getElementsByTagName('cite')
				: null;
			var green_url_lasttag = (green_url_tags && green_url_tags.length)
				? green_url_tags[green_url_tags.length - 1]
				: null;

			elems.push({'url': mainURL, 'li': arr[i], 'div': elem_div, 'green_url_lasttag': green_url_lasttag});
		};
		
		/* hack */
		if (elems.length == 4 && !this.four_elems_met)
		{
			this.p.ST.debug(5, 'Four results met. Will retry in a moment');
			this.four_elems_met = true;
			return [];
		};
		this.four_elems_met = false;
		
		return elems;
	};
