var EXPORTED_SYMBOLS = ['CSimilarius'];

Components.utils.import("resource://similarius/google/process.jsm");
Components.utils.import("resource://similarius/bing/process.jsm");
Components.utils.import("resource://similarius/yahoo/process.jsm");

var CSimilarius = function(_window){
		
		this.init(_window);
		
		/* init processes */
		this.Processes = {};
		this.last_process_id = 0;
		
		var appcontent = _window.document.getElementById('appcontent');
		if (!appcontent) return;
		appcontent.addEventListener('DOMContentLoaded', function(t){return function(aEvent){
			var doc = aEvent.originalTarget;
			if (!doc || !doc.nodeName || doc.nodeName != '#document' || doc.defaultView.parent !== doc.defaultView) return;
			t.debug(1, 'addProcess');
			t.addProcess(doc);
		}}(this), true);
	}

var ClassConstructor = CSimilarius;
	
/* INIT */
	ClassConstructor.prototype.init = function(_window){
		
			this.window = _window;
			
			/* enabled/disabled */
			this.toggle(this.getPref('bool', 'enabled', true));

			/* notices */
			var CNotice = function(p,name){this.p=p;this.name='notices.'+name;this.enabled=this.p.getPref('bool',this.name,true)}
			CNotice.prototype.enable = function(en){if ((en && this.enabled) || (!en && !this.enabled)) return; this.enabled = !this.enabled; this.p.setPref('bool', this.name,this.enabled) }
			CNotice.prototype.disable = function(){this.enable(false)}
			this.Notices = { 'new': new CNotice(this,'new'), 'all': new CNotice(this,'all') };
			
			/* check weather to load avg_cpc and exact_search_volume */
			this.noKeywordParams = this.getPref('bool', 'nokwparams');

			/* object for cookie operations */
			this.cookieSvc = Components.classes["@mozilla.org/cookieService;1"].getService(Components.interfaces.nsICookieService);  
			
			/* urlbar sign */
			this.Urlicon = this.window.document.getElementById('similarius-urlicon');
			this.Urlicon.src = 'chrome://similarius/skin/statusbaricon_on.png';
			this.Urlicon.addEventListener('click', function(e){
					var url = _window.gBrowser.selectedBrowser.currentURI.spec;
					if (url.indexOf('about:') === 0) return;
					(function(url){
						var pw = _window.opener ? _window.opener : _window;
						if (!pw) return;
						try { pw.getBrowser().selectedTab = pw.getBrowser().addTab(url); }
						catch (exception) { pw.open(url); };
					})('http://www.similarius.com/site/'+_window.encodeURIComponent(url.replace(/^\w+:\/\//, '').replace(/\/.*$/, '')));
				}, false);
		
		}

/* CONFIG */
	ClassConstructor.prototype.Config = {
		'timeout':    1000,

		'Hosts': {
			'google': [
				'google.com', 'google.ru', 'google.co.uk', 'google.cz', 'google.pl', 'google.com.au', 'google.com.br',
				'google.pt', 'google.es', 'google.fr', 'google.ie', 'google.be', 'google.nl', 'google.ch', 'google.de',
				'google.it', 'google.gr', 'google.at', 'google.hr', 'google.hu', 'google.no', 'google.is', 'google.se',
				'google.fi', 'google.sk', 'google.lt', 'google.lv', 'google.ee', 'google.md', 'google.com.ua',
				'google.by', 'google.kz', 'google.az', 'google.ge', 'googe.iq', 'google.li', 'google.lu', 'google.ro',
				'google.si', 'google.co.in', 'google.ca', 'google.cn', 'google.com.hk', 'google.co.jp', 'google.com.tw'
				],
			'bing': [
				'bing.com'
				],
			'yahoo': [
				'yahoo.com', 'search.yahoo.com',
				'ru.yahoo.com', 'ru.search.yahoo.com',
				'uk.yahoo.com', 'uk.search.yahoo.com'
				]
			}
		}

/* PREFERERENCES */
	ClassConstructor.prototype.PrefManager = function(){
			if (!this.prefManager) this.prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			return this.prefManager;
		}
	ClassConstructor.prototype.setPref = function(type, name, val){
			var p = {'bool':{'s':'setBoolPref','d':false},'string':{'s':'setStringPref','d':''},'int':{'s':'setIntPref','d':0}};
			if (type in p) this.PrefManager()[p[type].s]('extensions.similarius.'+name, val === undefined ? p[type].d : val);
			return val === undefined ? p[type].d : val;
		}
	ClassConstructor.prototype.getPref = function(type, name, _default){
			var p = {'bool':'getBoolPref','string':'getStringPref','int':'getIntPref'};
			if (!(type in p)) return _default;
			try { return this.PrefManager()[p[type]]('extensions.similarius.'+name) } catch (e) {};
			return this.setPref(type, name, _default);
		}

/* TOGGLE */
	ClassConstructor.prototype.OpenSimilar = function(){
			var url = this.window.gBrowser.selectedBrowser.currentURI.spec;
			if (url.indexOf('about:') === 0) return;
			url = 'http://www.similarius.com/site/'+this.window.encodeURIComponent(url.replace(/^\w+:\/\//, '').replace(/\/.*$/, ''));
			var parentWindow = this.window.opener ? this.window.opener : this.window;
			if (!parentWindow) return;
			try { parentWindow.getBrowser().selectedTab = parentWindow.getBrowser().addTab(url); }
			catch (exception) { parentWindow.open(url) }
		};
	ClassConstructor.prototype.toggle = function(state){
			
			this.state = (state === undefined) ? !this.state : state ? true : false;
			if (!this.Button)
			{
				this.Button = this.window.document.getElementById('similarius-panel');
				//this.Button.addEventListener('click', function(t){return function(){t.toggle()}}(this), false);
				this.Button.addEventListener('click', function(t){return function(){t.OpenSimilar()}}(this), false);
			};
			if (this.Button) this.Button.src = 'chrome://similarius/skin/statusbaricon_'+(this.state ? 'on' : 'off')+'.png';
			this.setPref('bool', 'enabled', this.state);

			/* parsing not parsed documents */
			if (this.state)
				for (var i in this.Processes)
					if (this.Processes[i].engine == 'yahoo' || this.Processes[i].engine == 'bing')
						this.Processes[i].Process(true);
		}



/* DEBUG */
	ClassConstructor.prototype.Console = function(){
			if (!this.console) this.console = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
			return this.console;
		}
	ClassConstructor.prototype.debug = function(level, message){
			if (this.debugLevel === undefined) this.debugLevel = this.getPref('int', 'debuglevel', 0);
			if (this.debugLevel >= (level||1)) this.Console().logStringMessage(message);
		}
	ClassConstructor.prototype.log = function(message){
			this.Console().logStringMessage(message);
		}

/* PROCESSES */
	ClassConstructor.prototype._is = function(engine, host){
			for (var i = 0; i < this.Config.Hosts[engine].length; i++)
				if (this.Config.Hosts[engine][i] == host || 'www.'+this.Config.Hosts[engine][i] == host)
					return true;
		}
		
	ClassConstructor.prototype.addProcess = function(doc){
			var url = doc.defaultView.location.href.replace(/^https?:\/\//, ''); /* check if process must indeed be executed */
			if (this._is('google', doc.domain))
			{
				if (url.replace(/^[^\/]*\//, '').substr(0,4) == '?url') return; /* do not execute on opening google links */
				var id = ++this.last_process_id;
				this.Processes[id] = new CGoogleProcess(this, doc, url);
				var _this = this;
				doc.defaultView.addEventListener('unload', function(){_this.Processes[id].destroy();delete _this.Processes[id];}, true);
				//doc.defaultView.addEventListener('hashchange', function(){_this.window.setTimeout(function(){_this.Processes[id].Process()}, _this.Config.timeout) }, false);
				_this.Processes[id].Process();
				//this.window.setTimeout(function(){_this.Processes[id].Process()}, _this.Config.timeout);
			}
			else if (this._is('bing', doc.domain))
			{
				var getstring = url.replace(/^[^\/]*\//, '');
				if (getstring && getstring.substr(0,7) != 'search?') return; /* execute only for search pages */
				
				var id = ++this.last_process_id;
				this.Processes[id] = new CBingProcess(this, doc, url);
				doc.defaultView.addEventListener('unload', function(_this, id){return function(){ _this.Processes[id].destroy(); delete _this.Processes[id]; }}(this, id), true);
				this.Processes[id].Process();
			}
			else if (this._is('yahoo', doc.domain))
			{
				var getstring = url.replace(/^[^\/]*\//, '');
				if (getstring && getstring.substr(0,7) != 'search;' && getstring.substr(0,7) != 'search?') return; /* execute only for search pages */
				
				var id = ++this.last_process_id;
				this.Processes[id] = new CYahooProcess(this, doc, url);
				doc.defaultView.addEventListener('unload', function(_this, id){return function(){ _this.Processes[id].destroy(); delete _this.Processes[id]; }}(this, id), true);
				this.Processes[id].Process();
			}
		}


